<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:25 CEST 2019 -->
<title>FbStatement (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="FbStatement (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6,"i5":6,"i6":6,"i7":6,"i8":6,"i9":6,"i10":6,"i11":6,"i12":6,"i13":6,"i14":6,"i15":6,"i16":6,"i17":6,"i18":6,"i19":6,"i20":6,"i21":6,"i22":6,"i23":6,"i24":6,"i25":6,"i26":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/FbServiceProperties.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/FbStatement.html" target="_top">Frames</a></li>
<li><a href="FbStatement.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng</div>
<h2 title="Interface FbStatement" class="title">Interface FbStatement</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Superinterfaces:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></dd>
</dl>
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/wire/FbWireStatement.html" title="interface in org.firebirdsql.gds.ng.wire">FbWireStatement</a></dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/AbstractFbStatement.html" title="class in org.firebirdsql.gds.ng">AbstractFbStatement</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/AbstractFbWireStatement.html" title="class in org.firebirdsql.gds.ng.wire">AbstractFbWireStatement</a>, <a href="../../../../org/firebirdsql/gds/ng/jna/JnaStatement.html" title="class in org.firebirdsql.gds.ng.jna">JnaStatement</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/version10/V10Statement.html" title="class in org.firebirdsql.gds.ng.wire.version10">V10Statement</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/version11/V11Statement.html" title="class in org.firebirdsql.gds.ng.wire.version11">V11Statement</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/version12/V12Statement.html" title="class in org.firebirdsql.gds.ng.wire.version12">V12Statement</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/version13/V13Statement.html" title="class in org.firebirdsql.gds.ng.wire.version13">V13Statement</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="typeNameLabel">FbStatement</span>
extends <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></pre>
<div class="block">API for statement handles.
 <p>
 All methods defined in this interface are required to notify all <code>SQLException</code> thrown from the methods
 defined in this interface.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#addStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">addStatementListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</code>
<div class="block">Registers a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#close--">close</a></span>()</code>
<div class="block">Close and deallocate this statement.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor--">closeCursor</a></span>()</code>
<div class="block">Closes the cursor associated with this statement, leaving the
 statement itself allocated.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor-boolean-">closeCursor</a></span>(boolean&nbsp;transactionEnd)</code>
<div class="block">Closes the cursor associated with this statement, leaving the statement itself allocated.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#emptyRowDescriptor--">emptyRowDescriptor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#ensureClosedCursor-boolean-">ensureClosedCursor</a></span>(boolean&nbsp;transactionEnd)</code>
<div class="block">Ensures that the statement cursor is closed.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#execute-org.firebirdsql.gds.ng.fields.RowValue-">execute</a></span>(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;parameters)</code>
<div class="block">Execute the statement.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#fetchRows-int-">fetchRows</a></span>(int&nbsp;fetchSize)</code>
<div class="block">Requests this statement to fetch the next <code>fetchSize</code> rows.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getDatabase--">getDatabase</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getDefaultSqlInfoSize--">getDefaultSqlInfoSize</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getExecutionPlan--">getExecutionPlan</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getExplainedExecutionPlan--">getExplainedExecutionPlan</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getFieldDescriptor--">getFieldDescriptor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getHandle--">getHandle</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getMaxSqlInfoSize--">getMaxSqlInfoSize</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getParameterDescriptor--">getParameterDescriptor</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/SqlCountHolder.html" title="class in org.firebirdsql.gds.ng">SqlCountHolder</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getSqlCounts--">getSqlCounts</a></span>()</code>
<div class="block">Retrieves the SQL counts for the last execution of this statement.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getSqlInfo-byte:A-int-">getSqlInfo</a></span>(byte[]&nbsp;requestItems,
          int&nbsp;bufferLength)</code>
<div class="block">Request statement info.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getSqlInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">getSqlInfo</a></span>(byte[]&nbsp;requestItems,
          int&nbsp;bufferLength,
          <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;T&gt;&nbsp;infoProcessor)</code>
<div class="block">Request statement info.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getState--">getState</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getTransaction--">getTransaction</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/StatementType.html" title="enum in org.firebirdsql.gds.ng">StatementType</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getType--">getType</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#prepare-java.lang.String-">prepare</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;statementText)</code>
<div class="block">Prepare the statement text.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#removeStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">removeStatementListener</a></span>(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</code>
<div class="block">Removes a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#setCursorName-java.lang.String-">setCursorName</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;cursorName)</code>
<div class="block">Sets the named cursor name for this statement.</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#setTransaction-org.firebirdsql.gds.ng.FbTransaction-">setTransaction</a></span>(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;transaction)</code>
<div class="block">Associates a transaction with this statement</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#validateParameters-org.firebirdsql.gds.ng.fields.RowValue-">validateParameters</a></span>(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;parameters)</code>
<div class="block">Validates if the number of parameters matches the expected number and types, and if all values have been set.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.firebirdsql.gds.ng.listeners.ExceptionListenable">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.firebirdsql.gds.ng.listeners.<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">addExceptionListener</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">removeExceptionListener</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getTransaction--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTransaction</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;getTransaction()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Transaction currently associated with this statement</dd>
</dl>
</li>
</ul>
<a name="getDatabase--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDatabase</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>&nbsp;getDatabase()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The database connection that created this statement</dd>
</dl>
</li>
</ul>
<a name="setTransaction-org.firebirdsql.gds.ng.FbTransaction-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTransaction</h4>
<pre>void&nbsp;setTransaction(<a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng">FbTransaction</a>&nbsp;transaction)
             throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Associates a transaction with this statement</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>transaction</code> - The transaction</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="getParameterDescriptor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getParameterDescriptor</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;getParameterDescriptor()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>descriptor of the parameters of this statement</dd>
</dl>
</li>
</ul>
<a name="getFieldDescriptor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getFieldDescriptor</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;getFieldDescriptor()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>descriptor of the fields returned by this statement</dd>
</dl>
</li>
</ul>
<a name="getType--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getType</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/StatementType.html" title="enum in org.firebirdsql.gds.ng">StatementType</a>&nbsp;getType()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The statement type</dd>
</dl>
</li>
</ul>
<a name="getState--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getState</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/StatementState.html" title="enum in org.firebirdsql.gds.ng">StatementState</a>&nbsp;getState()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The current state of this statement</dd>
</dl>
</li>
</ul>
<a name="getHandle--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getHandle</h4>
<pre>int&nbsp;getHandle()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The Firebird statement handle identifier</dd>
</dl>
</li>
</ul>
<a name="close--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>void&nbsp;close()
    throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Close and deallocate this statement.</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="closeCursor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeCursor</h4>
<pre>void&nbsp;closeCursor()
          throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Closes the cursor associated with this statement, leaving the
 statement itself allocated.
 <p>
 Equivalent to calling <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#closeCursor-boolean-"><code>closeCursor(boolean)</code></a> with <code>false</code>.
 </p></div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="closeCursor-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>closeCursor</h4>
<pre>void&nbsp;closeCursor(boolean&nbsp;transactionEnd)
          throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Closes the cursor associated with this statement, leaving the statement itself allocated.
 <p>
 When this method is called in preparation of a commit or rollback (see <code>transactionEnd</code>), then
 implementations may opt to not close the cursor on the server if the server closes the cursor automatically.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>transactionEnd</code> - Close is in response to a transaction end.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="prepare-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>prepare</h4>
<pre>void&nbsp;prepare(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;statementText)
      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Prepare the statement text.
 <p>
 If this handle is in state <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#NEW"><code>StatementState.NEW</code></a> then it will first allocate the statement.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>statementText</code> - Statement text</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If a database access error occurs, or this statement is currently executing a query.</dd>
</dl>
</li>
</ul>
<a name="validateParameters-org.firebirdsql.gds.ng.fields.RowValue-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>validateParameters</h4>
<pre>void&nbsp;validateParameters(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;parameters)
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Validates if the number of parameters matches the expected number and types, and if all values have been set.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parameters</code> - Parameter values to validate</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - When the number or type of parameters does not match <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getParameterDescriptor--"><code>getParameterDescriptor()</code></a>, or when a
         parameter has not been set.</dd>
</dl>
</li>
</ul>
<a name="execute-org.firebirdsql.gds.ng.fields.RowValue-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>execute</h4>
<pre>void&nbsp;execute(<a href="../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;parameters)
      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Execute the statement.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parameters</code> - The list of parameter values to use for execution.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - When the number of type of parameters does not match the types returned by <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html#getParameterDescriptor--"><code>getParameterDescriptor()</code></a>,
         a parameter value was not set, or when an error occurred executing this statement.</dd>
</dl>
</li>
</ul>
<a name="fetchRows-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>fetchRows</h4>
<pre>void&nbsp;fetchRows(int&nbsp;fetchSize)
        throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Requests this statement to fetch the next <code>fetchSize</code> rows.
 <p>
 Fetched rows are not returned from this method, but sent to the registered <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a> instances.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>fetchSize</code> - Number of rows to fetch (must be <code>&gt; 0</code>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - For database access errors, when called on a closed statement, when no cursor is open or when the fetch
         size is not <code>&gt; 0</code>.</dd>
</dl>
</li>
</ul>
<a name="addStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addStatementListener</h4>
<pre>void&nbsp;addStatementListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</pre>
<div class="block">Registers a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>statementListener</code> - The row listener</dd>
</dl>
</li>
</ul>
<a name="removeStatementListener-org.firebirdsql.gds.ng.listeners.StatementListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeStatementListener</h4>
<pre>void&nbsp;removeStatementListener(<a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners">StatementListener</a>&nbsp;statementListener)</pre>
<div class="block">Removes a <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>statementListener</code> - The row listener</dd>
</dl>
</li>
</ul>
<a name="getSqlInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSqlInfo</h4>
<pre>&lt;T&gt;&nbsp;T&nbsp;getSqlInfo(byte[]&nbsp;requestItems,
                 int&nbsp;bufferLength,
                 <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;T&gt;&nbsp;infoProcessor)
          throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Request statement info.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>requestItems</code> - Array of info items to request</dd>
<dd><code>bufferLength</code> - Response buffer length to use</dd>
<dd><code>infoProcessor</code> - Implementation of <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng"><code>InfoProcessor</code></a> to transform
         the info response</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Transformed info response of type T</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - For errors retrieving or transforming the response.</dd>
</dl>
</li>
</ul>
<a name="getSqlInfo-byte:A-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSqlInfo</h4>
<pre>byte[]&nbsp;getSqlInfo(byte[]&nbsp;requestItems,
                  int&nbsp;bufferLength)
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Request statement info.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>requestItems</code> - Array of info items to request</dd>
<dd><code>bufferLength</code> - Response buffer length to use</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Response buffer</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="getDefaultSqlInfoSize--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDefaultSqlInfoSize</h4>
<pre>int&nbsp;getDefaultSqlInfoSize()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The default size to use for the sql info buffer</dd>
</dl>
</li>
</ul>
<a name="getMaxSqlInfoSize--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMaxSqlInfoSize</h4>
<pre>int&nbsp;getMaxSqlInfoSize()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The maximum size to use for the sql info buffer</dd>
</dl>
</li>
</ul>
<a name="getExecutionPlan--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExecutionPlan</h4>
<pre><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getExecutionPlan()
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The execution plan of the currently prepared statement</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed.</dd>
</dl>
</li>
</ul>
<a name="getExplainedExecutionPlan--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getExplainedExecutionPlan</h4>
<pre><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getExplainedExecutionPlan()
                          throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The detailed execution plan of the currently prepared statement</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed.</dd>
</dl>
</li>
</ul>
<a name="getSqlCounts--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSqlCounts</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/SqlCountHolder.html" title="class in org.firebirdsql.gds.ng">SqlCountHolder</a>&nbsp;getSqlCounts()
                     throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Retrieves the SQL counts for the last execution of this statement.
 <p>
 The retrieved SQL counts are also notified to all registered <a href="../../../../org/firebirdsql/gds/ng/listeners/StatementListener.html" title="interface in org.firebirdsql.gds.ng.listeners"><code>StatementListener</code></a>s.
 </p>
 <p>
 In general the <a href="../../../../org/firebirdsql/gds/ng/FbStatement.html" title="interface in org.firebirdsql.gds.ng"><code>FbStatement</code></a> will (should) retrieve and notify listeners of the SQL counts automatically at times were
 it is relevant (eg after executing a statement that does not produce multiple rows, or after fetching all rows).
 </p></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The SQL counts of the last execution of this statement</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed, or if this statement is in state <a href="../../../../org/firebirdsql/gds/ng/StatementState.html#CURSOR_OPEN"><code>StatementState.CURSOR_OPEN</code></a> and not
         all rows have been fetched.</dd>
</dl>
</li>
</ul>
<a name="setCursorName-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setCursorName</h4>
<pre>void&nbsp;setCursorName(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;cursorName)
            throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Sets the named cursor name for this statement.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>cursorName</code> - Name of the cursor</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed, TODO: Other reasons (eg cursor open)?</dd>
</dl>
</li>
</ul>
<a name="emptyRowDescriptor--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>emptyRowDescriptor</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;emptyRowDescriptor()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>A potentially cached empty row descriptor for this statement or database.</dd>
</dl>
</li>
</ul>
<a name="ensureClosedCursor-boolean-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>ensureClosedCursor</h4>
<pre>void&nbsp;ensureClosedCursor(boolean&nbsp;transactionEnd)
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Ensures that the statement cursor is closed. Resets a statement so it is ready to be reused for re-execute or
 prepare.
 <p>
 Implementations should only close an open cursor and log this fact with a stacktrace on debug. This is a stopgap
 measure for situations where the code using this statement handle has not been able to properly close the
 cursor.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>transactionEnd</code> - Close is in response to a transaction end</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this statement is closed or the cursor could not be closed.</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0.6</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/FbServiceProperties.html" title="class in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/FbTransaction.html" title="interface in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/FbStatement.html" target="_top">Frames</a></li>
<li><a href="FbStatement.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
